#!/bin/sh
OTHERARG=""
KILL_LIST="ccafe-client java mpirun"
JAVA=java
HOST=127.0.0.1
PORT="NO PORT GIVEN"
# process the command line stuff before validating io locations
i=$#
while [ $i -gt 0 ]
do
	i=`expr $i - 1`
	arg=$1
	case $arg in

	"--help")
		cat << __EOF 
$0 --port <port> [options]

	--kill  		crudely wipe out the Ccaffeine frontend/backend
				run previously. 


        --debug         [0,1]   be less or more verbose in launching.


	--help  		this message.


	--host <host> (required if you are connecting remotely)
	  
          This is the host on which the backend is running the possible 
          problems with this switch mirror that of "--builderPort" or 
	  "--port", see below.


	--builderPort <port number>  same as --port


	--port <port number> (required)

	  A free port for which this program will be the client. Note
	  that this must match the "--port" param given to the
	  "gui-backend.sh" command and the gui-backend.sh server
	  *must* be started first for this program to have something
	  to connect to.  If you get a "connection refused" message,
	  it means that there is nothing seriving the port you have
	  chosen. If you get:

Exception in RemoteServer:java.net.ConnectException: Connection refused

	  Then there is nothing listening to that socket.


__EOF
		exit 0
		;;

	"--kill")
		killall $KILL_LIST >/dev/null 2>&1
		sleep 2
		killall -9 $KILL_LIST >/dev/null 2>&1
		exit 0
		;;

	"--port")
		shift
		PORT=$1
		;;

	"--builderPort")
		shift
		PORT=$1
		;;

	"--host")
		shift
		HOST="$1"
		;;

        "--debug")
                shift
                DEBUG="1"
                ;;

	*)
		OTHERARG="$OTHERARG $arg"
		if [ "x$DEBUG" != "x" ]
		then
		    echo "arg =" $arg
		    echo "OTHERARG = " $OTHERARG
		fi
	        ;;
        esac
	if [ $# -gt 0 ]; then
		shift
	fi
	i=$#
done

if [ "$PORT" = "NO PORT GIVEN" ]; 
then
    echo "No --port switch was given.  This is required for this application."
    echo "The port number given here must match the port given to the GUI"
    echo "If you are not sure try some of these numbers: 3645,2470,8211"
    echo "Any number above 1024 and lower than 0xffff that doesn't collide with something already using it will do."
    exit 0
fi

if [ "x$DEBUG" = "x1" ]
then
echo Command to launch the gui follows:
echo $JAVA -classpath /usr/share/java/ccafe-gui.jar gov.sandia.ccaffeine.dc.user_iface.BuilderClient --builderPort $PORT --host $HOST $OTHERARG
fi

$JAVA -classpath /usr/share/java/ccafe-gui.jar gov.sandia.ccaffeine.dc.user_iface.BuilderClient --builderPort $PORT --host $HOST $OTHERARG

